<template>
  <!-- FEEDBACK-BUTTON -->
  <div class="col-3 text-right">
    <app-link
      :path="`/${this.$i18n.locale}/feedback/form`"
      :query="getFeedbackQuery(getID, getTitle)"
      target="_blank">
      <button class="mt-1 btn btn-sm btn-light">
        {{ $t('message.datasetDetails.feedback') }}
      </button>
    </app-link>
  </div>
</template>

<script>
// Import Actions and Getters from Store Module
import { mapGetters } from 'vuex';
// Import custom helpers
import { has } from 'lodash';
import { getTranslationFor } from '../utils/helpers';
// Import components used in template
import AppLink from './AppLink';

export default {
  name: 'EDP2-datasetDetailsFeedbackButton',
  components: {
    appLink: AppLink,
  },
  data() {
    return {
      rootURL: 'https://www.europeandataportal.eu/',
    };
  },
  computed: {
    // import store-getters
    ...mapGetters('datasetDetails', [
      'getID',
      'getLanguages',
      'getTitle',
    ]),
  },
  methods: {
    // Lodash has function
    has,
    getTranslationFor,
    // Creates the query string for the feedback URL of the dataset
    getFeedbackQuery(id, titles) {
      // TODO: Show error message if ID or titles of dataset not available --> Feedback Link will not work
      if (!id || !titles || (typeof titles !== 'object')) return '';
      // Get translated title
      let title = this.getTranslationFor(titles, this.$i18n.locale, this.getLanguages);
      // TODO: Show error message if title of dataset not available --> Feedback Link will not work
      if (!title) return '';
      title = title.replace(/ /g, '+');
      // Create query string
      const type = '3';
      const description = `${this.$t('message.datasetDetails.subnav.dataset')}+URL:+${this.rootURL}datasets/${id}`;
      const summary = `${this.$t('message.datasetDetails.feedback')}+${this.$t('message.datasetDetails.about')}+${this.$t('message.datasetDetails.subnav.dataset')}:+${title}`;
      // Return query string
      return `?type=${type}&description=${description}&summary=${summary}`;
    },
  },
};
</script>

<style scoped>

</style>
